﻿using System.Collections.Generic;

namespace SingletonExampleComparer
{
    // singleton, eager initialization
    public class TeacherNameComparer : IComparer<Teacher>
    {
        private TeacherNameComparer() { /* private constructor */ }

        private static readonly TeacherNameComparer _instance = new TeacherNameComparer();

        public static TeacherNameComparer Instance
        {
            get { return _instance; }
        }

        public int Compare(Teacher x, Teacher y)
        {
            return x.Name.CompareTo(y.Name);
        }
    }
}
