﻿using System;
using System.Collections.Generic;

namespace SingletonExampleComparer
{
    // Singleton, lazy instantiation
    public class TeacherSalaryComparer : IComparer<Teacher>
    {
        private TeacherSalaryComparer() { /* private constructor */ }

        private static TeacherSalaryComparer _instance = null;
        private static readonly Object LockObject = new object();

        public static TeacherSalaryComparer Instance
        {
            get
            {
                if (_instance == null)
                {
                    lock (LockObject)
                    {
                        if (_instance == null)
                        {
                            _instance = new TeacherSalaryComparer();
                        }
                    }
                }
                return _instance;
            }
        }

        public int Compare(Teacher x, Teacher y)
        {
            return x.Salary.CompareTo(y.Salary);
        }
    }
}
