﻿using System.Collections.Generic;

namespace SingletonExampleComparer
{
    public static class Utils
    {
        // Extension method
        public static IComparer<T> Reverse<T>(this IComparer<T> comparer)
        {
            return new ReverseComparer<T>(comparer);
        }

        // ordinary method
        public static IComparer<T> Reverse2<T>(IComparer<T> comparer)
        {
            return new ReverseComparer<T>(comparer);
        }
    }

    class ReverseComparer<T> : IComparer<T>
    {
        public ReverseComparer(IComparer<T> comp)
        {
            Comp = comp;
        }

        public IComparer<T> Comp { get; private set; }

        public int Compare(T x, T y)
        {
            return Comp.Compare(y, x);
        }
    }
}
